package de.uka.ipd.algorithms.cfg;

import java.util.ArrayList;

/**
 * a node in a control flow graph
 *  (name and label are just there for debugging/visualisation purposes)
 */
public class CFGNode {
	protected ArrayList<CFGNode> preds = new ArrayList<CFGNode>();
	protected ArrayList<CFGNode> succs = new ArrayList<CFGNode>();
	protected String name;
	protected String label;
	protected int    index;
	
	/* protected, create your nodes with CFG.createNode */
	protected CFGNode(String name, int index) {
		this.name  = name;
		this.index = index;
	}
	
	public Iterable<CFGNode> getPreds() {
		return preds;
	}
	
	public Iterable<CFGNode> getSuccs() {
		return succs;
	}
	
	public void addSucc(CFGNode succ) {
		succs.add(succ);
		succ.preds.add(this);
	}
	
	public String getName() {
		return name;
	}
	
	public String getLabel() {
		if(label == null) {
			return getName();
		}
		return label;
	}
	
	public void setLabel(String label) {
		this.label = label;
	}
	
	public int getIndex() {
		return index;
	}
}
