package de.uka.ipd.algorithms;

import java.io.File;
import java.io.PrintStream;

import de.uka.ipd.algorithms.cfg.CFG;
import de.uka.ipd.algorithms.cfg.CFGNode;

public class test {
	
	/**
	 * Simple testprogram for lengauer tarjan algorithm
	 */
	public static void main(String[] args) {
		CFG cfg = new CFG();
		
		CFGNode na = cfg.createNode("A");
		CFGNode nb = cfg.createNode("B");
		CFGNode nc = cfg.createNode("C");
		CFGNode nd = cfg.createNode("D");
		CFGNode ne = cfg.createNode("E");
		CFGNode nf = cfg.createNode("F");
		CFGNode ng = cfg.createNode("G");
		CFGNode nh = cfg.createNode("H");
		
		cfg.getStart().addSucc(na);
		cfg.getStart().addSucc(cfg.getEnd());
		cfg.getStart().addSucc(ne);
		na.addSucc(nb);
		na.addSucc(nc);
		nb.addSucc(cfg.getEnd());
		nc.addSucc(nd);
		nc.addSucc(ne);
		nc.addSucc(nh);
		nd.addSucc(nf);
		ne.addSucc(nf);
		nf.addSucc(ng);
		ng.addSucc(nh);
		ng.addSucc(nc);
		nh.addSucc(cfg.getEnd());
		
		LengauerTarjan.DoLengauerTarjan(cfg);
		
		try {
			File        file = File.createTempFile("compilertest", ".dot");
			PrintStream out  = new PrintStream(file);
			cfg.printDotFile(out);
			out.close();
			
			Runtime.getRuntime().exec(new String[] { "dotty", file.toString() } );
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
